{
	open STGAParser
	let lineNo = ref 1
}
rule token = parse
	[' ''\t']	{ token lexbuf }     (* skip blanks *)
       |'\n' { lineNo := !lineNo + 1; token lexbuf }
	|['0'-'9']+	as id 		{ NUM(int_of_string id) }
	|"_true" {TRUE}
	|"_false" {FALSE}
	|"_tau" {TAU}
	|"_and" {AND}
	|"_not" {NOT}
	|"_or" {OR}
	|"_A" {A}
	|"_E" {E}
	|"_U" {U}
	|"_G" {G}
	|['a'-'z''A'-'Z']['a'-'z''A'-'Z''0'-'9''_''\'']* as name	{ NAME(name) }
	|'<' {LE}
	|"<=" {LEQ}
	|'>' {GE}
	|">=" {GEQ}
	|"!=" {NEQ}
	|":=" {ASSIGN}
	|"==" {EQ}
	|'=' {EQ}
	|"&&" {AND}
	|"||" {OR}
	|'+' {PLUS}
	|'-' {MINUS}
	|'*' {MUL}
	|'/' {DIV}
	|'%' {MOD}
	|'{' {LBBRACKET}
	|'}' {RBBRACKET}
	|'[' {LBRACKET}
	|']' {RBRACKET}
	|'(' {LPARENTHESE}
	|')' {RPARENTHESE}
	|':' {COLON}
	|';' {SEMICOLON}
	|',' {COMMA}
	|'?' {QMARK}
	|'!' {EXCLAMATION}
	|eof {EOF}

