    exception NONSENSEGRAPH of string
    exception INVALIDCONTEXT

    type exp = Expression.exp
    type allNodeSet = Set.Make(NodeSet.OrderedNode).t
    type allEdgeSet = Set.Make(EdgeSet.OrderedEdge).t
    type allNodeList = Graph.node list
    type allEdgeList = Graph.edge list
    type nodeSetSet = Set.Make(NodeSetSet.OrderedNodeSet).t
    type state = int * exp ref list ref    
    type graphMIB = { numof : int; initVal : exp ref list ref; nodeList : allNodeList ref; edgeList : allEdgeList ref; equivNodeSets : nodeSetSet ref; cmG : BinaryMatrix.binaryMatrix}
    type symbolicGraph = allNodeSet ref * allEdgeSet ref

    val graphInfo : graphMIB ref
    
    val buildCM :
      allNodeSet ref -> allEdgeSet ref -> int -> allEdgeList ref -> BinaryMatrix.binaryMatrix
    val buildActionCM :
      symbolicGraph -> Graph.action ref -> BinaryMatrix.binaryMatrix
    val reachabilityCheck :
      symbolicGraph -> unit
    val getNextState : int -> Graph.assign ref -> state
    val printGraph :
      symbolicGraph -> unit
    val edgeList2String : int list -> allNodeList ref -> allEdgeList ref -> string

    val getVarNameList : string -> exp ref list ref -> unit
    val getVarValueList : int -> exp ref list ref -> unit

    val compareState : state -> state -> int
    val printState : state -> unit
    val logState : state -> unit

    val tauPrunning : allNodeSet ref -> allEdgeSet ref -> allEdgeList ref -> unit
    