#include <time.h>
#include <stdio.h>
#include <assert.h>
#include <string.h>

#define isNum(p)	((*p) >= '0' && (*p) <= '9')
#define NUM(p)	((*p) - '0')

int tag[] = {-1, 0, 1, 2, 3, 4, -1, 5, 6, -1, 7, 8, 9, 11, 17, 19, 20, 21, 22, 24, 26, 28, 30};

const char *if_header =
"CODING ./CODING/PROMELA\n\
# IUTTIMEOUT 15\n\
# IUTTIMEOUT 6\n\
\n\
MUTANTS confprot.cov.mutants\n\
\n\
IUTTIMEOUT 2\n\
IUTCONTEXT hexcontext\n\
IUTCONTEXTFLAGS --\n\
# MAXSTEPS 0\n\
\n\
# for input, the conversion function of the INPUT def IS used\n\
# for input, the pcoOf function of the INPUT def for CFSAP is NOT used\n\
# for input, the pcoOf function of the INPUT def for udp IS used\n\
# for output, the conversion function of the OUTPUT def is NOT used\n\
# for input, the pcoOf function of the OUTPUT def is NOT used\n\
INPUT  from_upper   { CFAddr CFsp } enCodingOfCFsp\n\
OUTPUT to_upper     { CFAddr CFsp }\n\
INPUT  from_lower   { udpAddr udpsp } enCodingOfUdp pcoOfUdp\n\
OUTPUT to_lower     { udpAddr udpsp } deCodingOfUdp pcoOfUdp\n\
\n\
ADDRESS cf1   pipe\n\
ADDRESS 1     udp localhost 1075 {--port ${P}}\n\
ADDRESS 0     udp localhost 1076 {--port ${P}}\n\
ADDRESS 2     udp localhost 1077 {--port ${P}}\n\
# ADDRESS 4     udp localhost 1078 {--port ${P}}\n\
\n\
# for input, the conversion function of the PCO def is NOT used\n\
# for output, the conversion function of the PCO def IS used\n\
PCO cf1  { to_upper from_upper } cf1 { SFsp_nl CFsp_nl2CFsp {RECVHEX[^\\n]+\\n} }\n\
PCO udp0 { to_lower from_lower } 0   { udp_nl udp_nl2udpsp {RECVHEX[^\\n]+\\n} }\n\
PCO udp2 { to_lower from_lower } 2   { udp_nl udp_nl2udpsp {RECVHEX[^\\n]+\\n} }\n\
# PCO 4  { to_lower from_lower } 4   { udp_nl udp_nl2udpsp {RECVHEX[^\\n]+\\n} }\n\
\n\
\n\
IUT ./IUT/confprotv3c/confprot.iut\n\
\n\
SPEC ./SPEC/PROMELA/confprot.%s.primer\n\
SPECSOURCE ./SPEC/PROMELA/confprot.%s.trojka\n\
CHOOSEINPUTS 1\n\
\n\
### we may want to use several SEEDs, to reproduce errors.\n\
# do not set seed -- it will be set from command line\n\
# SEED  4\n\
\n\
# LOGFILE LOGS/conference.log\n\
# do not specify logfile here; use from command line\n\
# LOGFILE LOGS/conference.trojka.log\n\
# LOGMON ../bin/plotit\n\
\n\
# next line used a log file as initial trace\n\
# TRACEFILE conf.trace";

const char *primer_header =
"#!/bin/sh\n\
## if TorX has been installed correctly,\n\
## instantiator should be in the PATH\n\
instantiator -s 0 -f  instantiator.config | ./confprot.%s";

const char *header =
"/* ---------------------------------header begin ---------------------------------------- */\n \
/* --------------------------------- constants ------------------------------- */\n\
\n\
#define N                        	3	/* MAX Number of participants to CS 	*/\n\
#define ZZ                      	0     /* Null message                    		*/\n\
#define My_Conf		   	51   /* for deterministic test 				*/\n\
#define My_Address	   	1     /* for deterministic test 				*/\n\
#define AnotherConf		52	/* for deterministic test 			*/\n\
#define My_Partner1		0	/* for deterministic test 			*/\n\
#define My_Partner2		2	/* for deterministic test 			*/\n\
\n\
/* ---------------------------------macros --------------------------------- */\n\
\
#define IF                      if ::\n\
#define FI                      :: else fi\n\
\n\
/* ---------------------------------user defined types ------------------------ */\n\
\n\
#define T_Msg			byte\n\
#define T_Address			byte\n\
\n\
mtype = {\n\
  JOIN, LEAVE, DREQ, DIND,              	/* Conference Service - SP's	*/\n\
  U_DREQ, U_DIND,                     	/* Multicast Service - SP's         	*/\n\
  PDU_JOIN, PDU_LEAVE,\n\
  PDU_DATA, PDU_ANSWER               	/* PDU Types                       	*/\n\
} ;\n\
\n\
#define	T_AddressSet(name)		byte name[N]\n\
\n\
#define ASET_RESET(s)                 \\\n\
	i = 0; \\\n\
        do \\\n\
        	:: (i < N) -> s[i]=0; i = i+1 \\\n\
        	:: (i >= N) -> break \\\n\
        od \\\n\
\n\
#define ASET_IS_MEMBER(s,x)	s[x]==1\n\
#define ASET_REMOVE(s,x)		s[x]=0\n\
#define ASET_ADD(s,x)			s[x]=1\n\
\n\
#define M_JOIN(arg1,arg2)		PDU_JOIN,arg1,arg2\n\
#define M_ANSWER(arg1,arg2)	PDU_ANSWER,arg1,arg2\n\
#define M_LEAVE(arg1,arg2)		PDU_LEAVE,arg1,arg2\n\
#define M_DATA(arg1,arg2)		PDU_DATA,arg1,arg2\n\
\n\
#define GETPDU(Originator, Destination, message) \\\n\
	from_lower?message, Originator,Destination\n\
\n\
#define MULTICAST(originator,peers,message) \\\n\
 	i=0; \\\n\
	do \\\n\
		:: (i < N ) -> if \\\n\
			:: (ASET_IS_MEMBER(peers,i)) -> \\\n\
				run trickproc(message,originator,i) \\\n\
			:: else -> skip \\\n\
			fi; \\\n\
			i = i+1 \\\n\
              :: (i >= N) -> break \\\n\
	od\n\
\n\
#define BROADCAST(originator, message) \\\n\
	i=0; \\\n\
	do \\\n\
       	:: (i < N) -> if \\\n\
			:: (i!=originator) -> \\\n\
				run trickproc(message, originator, i) \\\n\
			:: else  ->  skip \\\n\
			fi; \\\n\
			i = i+1 \\\n\
		:: (i >= N) -> break \\\n\
	od\n\
\n\
/*  -------------------------------- channels --------------------------------- */\n\
\n\
#ifdef TROJKA\n\
#define OBSERVABLE observable\n\
#else\n\
#define OBSERVABLE\n\
#endif\n\
\n\
chan from_upper	= [0] of { mtype, T_Msg, T_Msg } OBSERVABLE;      /* CSAP  = upper SAP      */\n\
chan to_upper		= [0] of { mtype, T_Msg, T_Msg } OBSERVABLE;\n\
chan from_lower	= [0] of { mtype, T_Msg, T_Msg, T_Address, T_Address } OBSERVABLE;   /* UCAP = lower SAP      */\n\
chan to_lower		= [0] of { mtype, T_Msg, T_Msg, T_Address, T_Address } OBSERVABLE;\n\
\n\
byte Nick2Address[256];		/* table for mapping nick to address */\n\
byte Address2Nick[256];		/* table for mapping address to nick */\n\
\n\
#define STORE(nick,address)	Nick2Address[nick]=address; \\\n\
							Address2Nick[address]=nick\n\
\n\
#define TO_ADDR(nick)		Nick2Address[nick]\n\
#define TO_NICK(address)	Address2Nick[address]\n\
\n\
/*  -------------------------------- proctype Conf_PE ------------------------- */\n\
\n\
proctype trickproc(byte arg1, arg2, arg3, arg4, arg5)\n\
{\n\
  to_lower!arg1,arg2,arg3,arg4,arg5\n\
}\n\
\n\
proctype Conf_PE(/*byte My_Address*/)		/* Conf_PE (address) */\n\
{\n\
  T_AddressSet(partners);		/* set of known partners            */\n\
  T_Address     p;				/* placeholder for source partner   */\n\
\n\
/*\n\
 * parameters for a single protocol entity\n\
 */\n\
\n\
  byte		My_Nick;			/* model user title */\n\
/*  byte		My_Conf;			model participating conference */\n\
\n\
/*\n\
 * parameters for serveral service primitives / PDUs\n\
 */\n\
\n\
  byte 		Originator;	/* model originator adress of incomming PDU */\n\
  byte		Nick;		/* model originator nick of incomming PDU */\n\
  byte		Conf;		/* model conference id */\n\
  byte		Length;		/* model length of an incomming message */\n\
  byte		Data;		/* model incomming message */\n\
  byte		Peer;		/* model receiver */\n\
\n\
/*\n\
 * Several variables for supporting\n\
 */\n\
  byte i;	/* help for index for multicast and broadcast trick */\n\
\n\
/*\n\
 * usage of a trick to multicast in all possible permutations\n\
 */\n\
  chan trick[N] = [1] of { mtype, T_Msg, T_Msg, T_Address, T_Address };\n\
\n\
  atomic{ASET_RESET(partners)} ;		/* initial set is empty */\n\
/* ---------------------------------header end -----------------------------------------*/\n";

const char *tailer =
"/* --------------------------------tailer begin -----------------------------------------*/\n\
}\n\
\n\
#ifndef TROJKA\n\
proctype environment() {\n\
	from_upper!JOIN(1,2);\n\
	from_upper!LEAVE(2,2);\n\
	from_upper!JOIN(2,2);\n\
	to_lower?PDU_JOIN,1,2,1,2;\n\
	to_lower?PDU_JOIN,2,2,1,2;\n\
	to_lower?PDU_JOIN,1,2,1,0;\n\
	to_lower?PDU_JOIN,2,2,1,0;\n\
}\n\
#endif\n\
\n\
/* --------------------------------- init --------------------------------- */\n\
init	{\n\
atomic {\n\
	run Conf_PE()\n\
#ifndef TROJKA\n\
	; run environment()\n\
#endif\n\
	}\n\
}\n\
/* --------------------------------tailer end -----------------------------------------*/\n";

const char *statement[] = {
// 4 -> 0
// 6 -> 0
"run trickproc(M_LEAVE(My_Nick, My_Conf), My_Address, My_Partner2)", // reset partner2

// 0 -> 1
// 4 -> 1
// 6 -> 1
"from_upper? JOIN(My_Nick, My_Conf)",

// 1 -> 2
"run trickproc(M_JOIN(My_Nick, My_Conf), My_Address, My_Partner1)",

// 2 -> 3
"run trickproc(M_JOIN(My_Nick, My_Conf), My_Address, My_Partner2)",

// 3 -> 4
// 7 -> 4
// 9 -> 4
// 10 -> 4
// 11 -> 4
// 12 -> 4
// 13 -> 4
// 14 -> 4
// 17 -> 4
// 18 -> 4
// 19 -> 4
// 20 -> 4
// 21 -> 4
"from_upper? LEAVE",

// 4 -> 6
"run trickproc(M_LEAVE(My_Nick, My_Conf), My_Address, My_Partner1)", // reset partner1

// 3 -> 7
// 7 -> 7
// 9 -> 7
// 10 -> 7
// 11 -> 7
// 12 -> 7
// 13 -> 7
// 14 -> 7
// 17 -> 7
// 18 -> 7
// 19 -> 7
// 20 -> 7
// 21 -> 7
"from_upper? DREQ(Length,Data)",

// 7 -> 9
"run trickproc(M_DATA(Length,Data), My_Address, My_Partner1)", // require partner1

// 7 -> 10
// 9 -> 10
"run trickproc(M_DATA(Length,Data), My_Address, My_Partner2)", // require partner2

// 3 -> 11
// 7 -> 11
// 9 -> 11
// 10 -> 11
// 11 -> 11
// 12 -> 11
// 13 -> 11
// 14 -> 11
// 17 -> 11
// 18 -> 11
// 19 -> 11
// 20 -> 11
// 21 -> 11
"from_lower? M_JOIN(Nick,My_Conf), My_Partner1, My_Address",  // -> 12,21
"from_lower? M_JOIN(Nick,AnotherConf), My_Partner1, My_Address",

// 11 -> 12 (My_Conf)
"to_lower! M_ANSWER(My_Nick, My_Conf), My_Address, My_Partner1", // require partner1
  
// 13 -> 12
"to_lower! M_ANSWER(My_Nick, My_Conf), My_Address, My_Partner2", // require partner2

// 15 -> 12
"to_lower! M_JOIN(My_Nick,My_Conf), My_Address, My_Partner1", // else
"to_upper! DIND(TO_NICK(My_Partner1),Data)", // if partner1

// 16 -> 12
"to_lower! M_JOIN(My_Nick,My_Conf), My_Address, My_Partner2", // else
"to_upper! DIND(TO_NICK(My_Partner2),Data)", // if partner2

// 3 -> 13
// 7 -> 13
// 9 -> 13
// 10 -> 13
// 11 -> 13
// 12 -> 13
// 13 -> 13
// 14 -> 13
// 17 -> 13
// 18 -> 13
// 19 -> 13
// 20 -> 13
// 21 -> 13
"from_lower? M_JOIN(Nick,My_Conf), My_Partner2, My_Address", // -> 12,14
"from_lower? M_JOIN(Nick,AnotherConf), My_Partner2, My_Address",

// 13 -> 14
"to_lower! M_ANSWER(My_Nick, My_Conf), My_Address, My_Partner2", // set partner2

// 3 -> 15
// 7 -> 15
// 9 -> 15
// 10 -> 15
// 11 -> 15
// 12 -> 15
// 13 -> 15
// 14 -> 15
// 17 -> 15
// 18 -> 15
// 19 -> 15
// 20 -> 15
// 21 -> 15
"from_lower? M_DATA(Length,Data), My_Partner1, My_Address",

// 3 -> 16
// 7 -> 16
// 9 -> 16
// 10 -> 16
// 11 -> 16
// 12 -> 16
// 13 -> 16
// 14 -> 16
// 17 -> 16
// 18 -> 16
// 19 -> 16
// 20 -> 16
// 21 -> 16
"from_lower? M_DATA(Length,Data), My_Partner2, My_Address",

// 3 -> 17
// 7 -> 17
// 9 -> 17
// 10 -> 17
// 11 -> 17
// 12 -> 17
// 13 -> 17
// 14 -> 17
// 17 -> 17
// 18 -> 17
// 19 -> 17
// 20 -> 17
// 21 -> 17
"from_lower? M_LEAVE(Nick, AnotherConf), My_Partner1, My_Address",
"from_lower? M_LEAVE(Nick, My_Conf), My_Partner1, My_Address", // reset partner1

// 3 -> 18
// 7 -> 18
// 9 -> 18
// 10 -> 18
// 11 -> 18
// 12 -> 18
// 13 -> 18
// 14 -> 18
// 17 -> 18
// 18 -> 18
// 19 -> 18
// 20 -> 18
// 21 -> 18
"from_lower? M_LEAVE(Nick, AnotherConf), My_Partner2, My_Address", 
"from_lower? M_LEAVE(Nick, My_Conf), My_Partner2, My_Address", // reset partner2

// 3 -> 19
// 7 -> 19
// 9 -> 19
// 10 -> 19
// 11 -> 19
// 12 -> 19
// 13 -> 19
// 17 -> 19
// 14 -> 19
// 18 -> 19
// 19 -> 19
// 20 -> 19
// 21 -> 19
"from_lower? M_ANSWER(Nick, AnotherConf), My_Partner1, My_Address", // require not partner1
"from_lower? M_ANSWER(Nick, My_Conf), My_Partner1, My_Address", //set partner1 // require not partner1

// 3 -> 20
// 7 -> 20
// 9 -> 20
// 10 -> 20
// 11 -> 20
// 12 -> 20
// 13 -> 20
// 14 -> 20
// 17 -> 20
// 18 -> 20
// 19 -> 20
// 20 -> 20
// 21 -> 20
"from_lower? M_ANSWER(Nick, AnotherConf), My_Partner2, My_Address", // require not partner2
"from_lower? M_ANSWER(Nick, My_Conf), My_Partner2, My_Address", // set partner2 //require not partner2

// 11 -> 21 (My_Conf)
"to_lower! M_ANSWER(My_Nick, My_Conf), My_Address, My_Partner1" // set partner1

};

int requirePartner1(char *s, int i)
{
	int j = 0;

	while (*s != '\0') {
		while ((*s != '\0') && !isNum(s)) s++;

		while (isNum(s)) {
			j = j * 10 + NUM(s);
			s ++;
		};

		if ((i == 7 && j == 9) ||(i == 11 && j == 12) ||
			(i == 4 && j == 6))
			return 1;
 
		i = j;
	}

	return 0;
}

int requirePartner2(char *s, int i)
{
	int j = 0;
	
	while (*s != '\0') {
		while ((*s != '\0') && !isNum(s)) s++;

		while (isNum(s)) {
			j = j * 10 + NUM(s);
			s ++;
		}

		if ((i == 7 && j == 10) ||(i == 9 && j == 10) || (i == 13 && j == 12) ||
			(i == 4 && j == 0) || (i == 6 && j == 0))
			return 1;
 
		i = j;
	}

	return 0;
}

int checkSeq(FILE *fp, char *s)
{
	int i = 0, j = 0;
	int partner1 = 0;
	int partner2 = 0;
	int offset = 0;
	int last = strlen(s) -1;
	int found = 0;
	int inAtomic = 0;

	if (!fp || !s) return -1;

	i = NUM((s+last));
	while (isNum((s+last))) {
		i = NUM((s+last))*10*(strlen(s)-last-1)+i;
		last --;
	}
	
	last = i;
	i = 0;

	while ((*s != '\0') && !isNum(s)) s++;

	while (isNum(s)) {
		i = i * 10 + NUM(s);
		s ++;
	}

	while (*s != '\0') {
		while ((*s != '\0') && !isNum(s)) s++;

		while (isNum(s)) {
			j = j * 10 + NUM(s);
			s ++;
		}

		if (i == last && !found) {
			fprintf(fp, "LOOP%d:\n", i);
			found = 1;
		}

		if (*s == '\0' && found && !inAtomic) {
			fprintf(fp, "atomic {\n");
			inAtomic = 1;
		}
			
		offset = 0;
		switch (j) {
		case 0: 	if (i == 4)
					assert(partner1 == 0);
				if (i == 4 || i == 6)
					assert(partner2 == 1);
				partner2 = 0; 
				break;
		case 1: 	if (i == 4)
					assert(partner1 == 0);
				if (i == 4 || i == 6)
					assert(partner2 == 0);
				break;
		case 2:	if (i == 1 && strncmp(s, "->3", 3) == 0 && !inAtomic) {
					fprintf(fp, "atomic {\n");
					inAtomic = 1;
				}	
				break;
		case 4: 	if (i == 7 || i == 19)
					assert(partner1 == 0);
				if (i == 7 || i == 9 || i == 20)
					assert(partner2 == 0);
				break;
		case 6: 	if (i == 4)
					assert(partner1 == 1);
				partner1 = 0; 
				if (i == 4 && strncmp(s, "->0", 3) == 0 && !inAtomic) {
					fprintf(fp, "atomic {\n");	
					inAtomic = 1;
				}
				break;
		case 7: 	if (i == 7 || i == 19)
					assert(partner1 == 0);
				if (i == 7 || i == 9 || i == 20)
					assert(partner2 == 0);
				break;
		case 9: 	if (i == 7)
					assert(partner1 == 1);
				if (i == 7 && strncmp(s, "->10", 4) == 0 && !inAtomic) {
					fprintf(fp, "atomic {\n");
					inAtomic = 1;
				}
				break;
		case 10: if (i == 7)
					assert(partner1 == 0);
				if (i == 7 || i == 9)
					assert(partner2 == 1);
				break;
		case 11: if (i == 7 || i == 19)
					assert(partner1 == 0);
				if (i == 7 || i == 9 || i == 20)
					assert(partner2 == 0);
				if (strncmp(s,"->12",4) && strncmp(s,"->21",4))
					offset = 1;
				break;
		case 12: if (i == 11)
					assert(partner1 == 1);
				if (i == 13)
					assert(partner2 == 1);
				if (i == 13) offset = 1;
				else if (i == 15) offset = 2 + partner1;
				else if (i == 16) offset = 4 + partner2;
				else assert(i == 11);
				break;
		case 13: if (i == 7 || i == 19)
					assert(partner1 == 0);
				if (i == 7 || i == 9 || i == 20)
					assert(partner2 == 0);
				if (strncmp(s,"->12",4) && strncmp(s,"->14",4))
					offset = 1;
				break;
		case 14: if (i == 13)
					assert(partner2 == 0);
				partner2 = 1; break;
		case 15:	if (i == 7 || i == 19)
					assert(partner1 == 0);
				if (i == 7 || i == 9 || i == 20)
					assert(partner2 == 0);
				break;
		case 16:	if (i == 7 || i == 19)
					assert(partner1 == 0);
				if (i == 7 || i == 9 || i == 20)
					assert(partner2 == 0);
				break;
		case 17: if (i == 7 || i == 19)
					assert(partner1 == 0);
				if (i == 7 || i == 9 || i == 20)
					assert(partner2 == 0);
				if (!requirePartner1(s, j)) {
					offset = 1;
					partner1 = 0;
				}
				break;
		case 18:	if (i == 7 || i == 19)
					assert(partner1 == 0);
				if (i == 7 || i == 9 || i == 20)
					assert(partner2 == 0);
				if (!requirePartner2(s, j)) {
					offset = 1;
					partner2 = 0;
				}
				break;
		case 19: if (i == 7 || i == 19)
					assert(partner1 == 0);
				if (i == 7 || i == 9|| i == 20)
					assert(partner2 == 0);
				if (requirePartner1(s, j)) {
					offset = 1;
					partner1 = 1;
				};
				break;
		case 20:	if (i == 7 || i == 19)
					assert(partner1 == 0);
				if (i == 7 || i == 9|| i == 20)
					assert(partner2 == 0);
				if (requirePartner2(s, j)) {
					offset = 1;
					partner2 = 1;
				};
				break;
		case 21: if (i == 11)
					assert(partner1 == 0);
				partner1 = 1;break;
		}
		
		fprintf(fp, "/* %d -> %d */\n  %s;\n", i, j, statement[tag[j+1]+offset]);
		if ((strncmp(s-8, ">1->2->3", 8) == 0 ||
			strncmp(s-9, ">7->9->10", 9) == 0 ||
				strncmp(s-8, ">4->6->0", 8) == 0) && inAtomic
				   && (!found || (*s != '\0'))) {	// found -> not yet reach the end // peng 06.06.2007
			fprintf(fp, "};\n");
			inAtomic = 0;
		}

		i = j;
		j = 0;
	}

	if (found)
		fprintf(fp, "goto LOOP%d;\n}\n", last);
								
	return 0;
}

int main(int argc, char *argv[])
{
	FILE *fp = NULL, *fp_tc = NULL;
	char linebuf[1024] = { 0 }, fname[30] = { 0 } , *p = NULL;
	int i,c;

	time_t timer;

	if (argc > 1)
		fp = fopen(argv[1], "r");

	if (fp) {
		while (fgets(linebuf, 1024, fp) != 0) {
		  	if (linebuf[0] != '#') continue;	// peng 06.06.2007
			i = 1;	// peng 06.06.2007
			while (linebuf[i] < '0' || linebuf[i] > '9') i ++;
			p = strtok(linebuf+i,":");
                        if (!p) continue;	// peng 06.06.2007
			c = atoi(p);
			sprintf(fname, "confprot.prom.cov.%s.if", p);
			fp_tc = fopen(fname, "w");
			if (fp_tc) {
				fprintf(fp_tc, if_header, p, p);
				fclose(fp_tc);
			}
			sprintf(fname, "confprot.%s.primer", p);
			fp_tc = fopen(fname, "w");
			if (fp_tc) {
				fprintf(fp_tc, primer_header, p);
				fclose(fp_tc);
			};
			sprintf(fname, "confprot.%s.trojka", p);
			fp_tc = fopen(fname, "w");
			if (fp_tc) {
				timer=time(NULL);
				p = strtok(NULL,"(");
				if (p) {	// peng 06.06.2007
					fprintf(fp_tc, "/* Test Case No.%d for the Conference Protocol in Promela, derived from the sequence\n\n%d:%s\n\nTime:%s*/\n", \
						c, c, p, asctime(localtime(&timer)));
					fprintf(fp_tc, "%s", header);
					checkSeq(fp_tc,p);
					fprintf(fp_tc, "%s", tailer);
					fclose(fp_tc);
				}
			}
			memset(linebuf,0,1024);
		}
		fclose(fp);		
	}
	
	return 0;
}

