#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>

#define BUFLEN		1024
#define NODENUM		22

typedef struct _tnode {
	int id;
	int count;
	struct _tnode *first;
	struct _tnode *next;
} TNode;

TNode *rt = NULL;
int mark[NODENUM][NODENUM] = { 0 };

#define isNum(p)	((*p) >= '0' && (*p) <= '9')
#define NUM(p)	((*p) - '0')

int checkSeq(char *s)
{
	char *p = NULL;
	int hn = 0;
	TNode *h = rt, *pre = NULL, *next = NULL, *ln = rt;

	
	p = strtok(s,"()");
	p = strtok(p,",\r\n");
	if (p) {
		while (isNum(p)) {
			hn = hn * 10 + NUM(p);
			p ++;
		}
	}
	while (p) {
		assert(*p == '-' && *(p+1) == '>');
		while (h && h->id != hn) {
			pre = h;
			h = h -> next;
		}
		p += 2;
		if (!h) {
//			printf("%d -> %s \n", hn, p);

			if (ln)
				mark[ln -> id][hn] = 1;
			h = (TNode *)malloc(sizeof(TNode));
			h -> first = NULL;
			h -> next = NULL;
			h -> id = hn;
			h -> count = 0;

			if (rt == NULL)
				rt = h;
			if (pre)
				pre -> next = h;
			if (ln && ln -> first == NULL)
				ln -> first = h;
		}
		ln = h;
		h = h->first;
		pre = NULL;
		hn = atoi(p);

		p=strtok(NULL,",\r\n");
		if (p)
			while (isNum(p))
				p ++;
	}

	while (h && h->id != hn) {
		pre = h;
		h = h -> next;
	}

	if (!h) {

		if (ln)
			mark[ln -> id][hn] = 1;

		h = (TNode *)malloc(sizeof(TNode));
		h -> first = NULL;
		h -> next = NULL;
		h -> id = hn;
		h -> count = 1;
		if (ln && ln -> first == NULL)
			ln -> first = h;
		if (pre)
			pre -> next = h;

//		printf(" %d => %d\n", ln -> id, hn);
	}
	else
		h -> count ++;
	
	return 0;
}

#define Free(n)	free(n)

int printSeq(TNode *n, char *buf)
{
	static i = 0;
	char localbuf[1024] = { 0 };
	TNode *u = NULL;

	if (n) {
		strcpy(localbuf, buf);
		sprintf(localbuf, "%s->%d", buf, n -> id);
		if (!(n -> first)) {
			printf("# %d: %s(%d times)\n", i, localbuf, n -> count);
			i ++;
//			Free(n);	// peng 05.06.2007
			return i;
		}
		n = n -> first;
		while (n) {
			printSeq(n, localbuf);
			u = n -> next;
			Free(n);
			n = u;
		}
	}

	return i;
}

int main(int argc, char *argv[])
{
	FILE *fp = NULL;
	char linebuf[1024] = { 0 }, *p = NULL;
	int i,j,c=0,c0=0;
	
	if (argc > 1)
		fp = fopen(argv[1], "r");

	if (fp) {
		while (fgets(linebuf, 1024, fp) != 0) {
			if (linebuf[0] != '#') {
				i = 0;
				while(linebuf[i] != '(') i ++;
				checkSeq(linebuf+i);
			}
			memset(linebuf,0,1024);
		}
		fclose(fp);		
	}

	while (rt) {
		int i = printSeq(rt,linebuf);
		memset(linebuf,0,1024);
		rt = rt -> next;
		printf("* %d test sequences.\n", i);
	} 

	for(i=0;i<NODENUM;i++)
		for(j=0;j<NODENUM;j++) {
			c += mark[i][j];
			if (((i == 15 || i == 16) && j == 12) ||
				((i == 17 || i == 18 || i == 19 || i == 20) &&
				 (j == 4 || j == 7 || j == 11 ||j == 13 || j == 15 || j == 16 || j == 17 || j == 18 || j == 19 || j == 20))) {
				 printf("* %d => %d\n", i, j);
				 c0 += mark[i][j];
			}
/*			if (mark[i][j])
				printf("# %d -> %d\n", i, j); */
		}
	printf("* %d edges included.\n", c + c0);
	
	return 0;
}

